// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

/* Generated by Together */

package de.uka.ilkd.key.casetool.together.keydebugclassloader;

import java.net.*;
import java.util.*;
import java.lang.reflect.*;

import com.togethersoft.openapi.ide.message.IdeMessageManagerAccess;
import com.togethersoft.openapi.ide.message.IdeMessageType;

import com.togethersoft.openapi.sci.pattern.SciPattern;

import de.uka.ilkd.key.casetool.together.keydebugclassloader.KeyDebugClassLoader;
import de.uka.ilkd.key.util.Debug;

import de.uka.ilkd.key.casetool.together.patterns.HelperClasses.MyPatternBase.*;


public abstract class KeyPattern extends MyClassPatternBase implements SciPattern {

    public String KEY_SET_METHOD;
    public String KEY_CONSTRUCTOR_PARAMETER;
    public String KEY_NONE;

    {   Field field = null;
	try {
	    field = getClass().getField("UI_NONE");
	} catch (Exception e) {
	}
	try {
	    if (field == null) {
		Debug.out("Together-API<6.0");
		KEY_SET_METHOD=(String)getClass().getField("SET_METHOD").get(this);
		KEY_CONSTRUCTOR_PARAMETER=(String)getClass().getField("CONSTRUCTOR_PARAMETER").get(this);
		KEY_NONE=(String)getClass().getField("NONE").get(this);
	    } else {
		Debug.out("Together-API>=6.0");
		KEY_SET_METHOD=(String)getClass().getField("UI_SET_METHOD").get(this);
		KEY_CONSTRUCTOR_PARAMETER=(String)getClass().getField("UI_CONSTRUCTOR_PARAMETER").get(this);
		KEY_NONE=(String)getClass().getField("UI_NONE").get(this);
	    }
	} catch (Exception e) {
	    System.out.println("Unexpected Error happened");
	    System.out.println("The exception was thrown in a part of the program "+
			       "used to manage API incompatibilities between 6.0 and below");
	    System.out.println("The thrown exception was "+e);
	    e.printStackTrace();
	}
	
    }

    private KeyPattern thisclone;

    public final boolean prepare(){
	int i;
	if("on".equals(System.getProperty("KeyDebugClassLoader"))){
	    thisclone = reloadClassDef();
	    //	    IdeMessageManagerAccess.printMessage(IdeMessageType.INFORMATION, "jetzt habe ich reload gemacht!\n");
	    Class cl = this.getClass();
	    Vector fieldVector = new Vector();
	    Field[] fields = cl.getDeclaredFields();
	    for (i = 0; i < fields.length; i++){fieldVector.addElement(fields[i]);}
	    Class help = cl;
	    while (help.getSuperclass()!=null){
		help = help.getSuperclass();
		fields = help.getDeclaredFields();
		for (i = 0; i < fields.length; i++){
		    fields[i].setAccessible(true);  // damit auch private der Oberklassen lesbar werden
		    fieldVector.addElement(fields[i]);}
	    }
	    for(i = 0; i < fieldVector.size(); i++){
		Field actField = (Field) fieldVector.elementAt(i);
		try{
		    //    System.out.println(actField.getName() + " mit wert " +  actField.get(this)+"\n");
		actField.set(thisclone, actField.get(this));
		}catch(Exception ex){
		    //    System.out.println(ex);
		}
		
	    }
	}
	else {
	    thisclone = this;
	}

    return thisclone.prepare1();
    }

    /* because we change the semantics of the original prepare method, we introduce this simulation method
       to invoke the prepare method in the super class */
    public final void superPrepareSimu(){
	super.prepare();
    }

    public boolean prepare1(){ return true; }

    public boolean canApply() { 
	return thisclone.canApply1();
    }
    
    public boolean canApply1(){
	return true;
    }

    public void apply() {
	thisclone.apply1();
    }
    
    public void apply1(){
    }

    public final void superApplySimu(){
	super.apply();
    }


    protected void finalize() throws Throwable {
	thisclone.finalize1();
    }

    protected void finalize1() throws Throwable{
    }

    protected void superFinalizeSimu() throws Throwable{
	super.finalize();
    }
    
    // reloads the class-definition of the this-object
    // and returns a new instance of it.
    private KeyPattern reloadClassDef() {
       	String thisClassName = this.getClass().getName();
	//	IdeMessageManagerAccess.printMessage(IdeMessageType.INFORMATION,"Name der nachgeladenen Klasse: "+thisClassName+"\n");
	try{
	    KeyDebugClassLoader classLoader = new KeyDebugClassLoader();
	    // Because of the explicit cast later KeyScript must not be 
	    // reloaded by KeyDebugClassLoader (otherwise we get an cast-error)
	    classLoader.setClassAlwaysAskParent(KeyPattern.class);
	    Class cl = classLoader.loadClass(thisClassName);
	    KeyPattern pattern = (KeyPattern) cl.newInstance();
	    return pattern;
	} catch (Exception e) {
	    System.err.println("KeYError in KeyPattern.java: " + e);
	    e.printStackTrace();
	    return null;
	}
    }
}
