// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.gui;


import de.uka.ilkd.key.logic.*;
import de.uka.ilkd.key.proof.Proof;
import de.uka.ilkd.key.logic.op.*;
import de.uka.ilkd.key.util.pp.*;
import java.io.IOException;

public class PresentationFeatures {


    public static boolean ENABLED=false;
    public static void modifyNotationInfo(NotationInfo notInfo,
					  Namespace functions) {
	if (ENABLED) {
	    notInfo.createInfixNotation
		((Function)functions.lookup(new Name("lt")),"< ");
	    notInfo.createInfixNotation
		((Function)functions.lookup(new Name("gt")),"> ");
	    notInfo.createInfixNotation
		((Function)functions.lookup(new Name("jlt")),"<");
	    notInfo.createInfixNotation
		((Function)functions.lookup(new Name("jgt")),">");
	    notInfo.createInfixNotation
		((Function)functions.lookup(new Name("leq")),"<=");
	    notInfo.createInfixNotation
		((Function)functions.lookup(new Name("geq")),">=");
	    notInfo.createInfixNotation
		((Function)functions.lookup(new Name("jleq")),"<=");
	    notInfo.createInfixNotation
		((Function)functions.lookup(new Name("=")),"=");
	    notInfo.createInfixNotation
		((Function)functions.lookup(new Name("jgeq")),">=");
	    notInfo.createInfixNotation
		((Function)functions.lookup(new Name("+")),"+");
	    notInfo.createInfixNotation
		((Function)functions.lookup(new Name("~d")),"-");
	    notInfo.createPrefixNotation
		((Function)functions.lookup(new Name("~m")),"-");
	    notInfo.createNumLitNotation
		((Function)functions.lookup(new Name("Z")));
	    notInfo.createPrefixNotation
		((Function)functions.lookup(new Name("neg")),"-");
	    
	}
    }

    private static StringBuffer printlastfirst(Term t) {
	if (t.op().arity()==0) {
	    return new StringBuffer();
	} else {
	    return printlastfirst(t.sub(0)).
		append(t.op().name().toString());
	}
    }

    public static String printNumberTerm(Term t) 
    {
	StringBuffer sb=new StringBuffer();
	if (t.sub(0).op().name().toString().equals("neg")) {
	    return "-"+
		printlastfirst(t.sub(0).sub(0)).toString();
	} else {
	    return printlastfirst(t.sub(0)).toString();
	}
    }

    public static void initialize(Namespace funcns, NotationInfo ni, Proof p) {
	if (ENABLED) {
	    modifyNotationInfo(ni, funcns);
	    p.updateProof();
	}	
    }

}
