// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001 Universitaet Karlsruhe, Germany
//                    and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General 
// Public License. See LICENSE.TXT for details.
//

package de.uka.ilkd.key.logic.sort;

import de.uka.ilkd.key.logic.Name;


public abstract class CollectionSort extends de.uka.ilkd.key.logic.sort.AbstractSort {

    de.uka.ilkd.key.logic.sort.Sort elementSort;
    
    /** creates a Sort (with a new equality symbol for this sort) */
    protected CollectionSort(String name, de.uka.ilkd.key.logic.sort.Sort elemSort) {
	super(new Name(name+"Of"+elemSort.name()));
	elementSort=elemSort;
    }

    public de.uka.ilkd.key.logic.sort.Sort elementSort() {
	return elementSort;
    }
   
    /**
     * @return the sorts of the predecessors of this sort
     */
    public SetOfSort extendsSorts() {
	return SetAsListOfSort.EMPTY_SET;
    }

    static CollectionSort createSetSort(de.uka.ilkd.key.logic.sort.Sort s) {
	return new SetSort(s);
    }

    static CollectionSort createBagSort(de.uka.ilkd.key.logic.sort.Sort s) {
	return new BagSort(s);
    }

    static CollectionSort createSequenceSort(de.uka.ilkd.key.logic.sort.Sort s) {
	return new SequenceSort(s);
    }

}
