// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.rule;

import de.uka.ilkd.key.logic.sort.Sort;
import de.uka.ilkd.key.logic.op.SchemaVariable;
import java.io.Serializable;
public class NewVarcond implements Serializable {

    private SchemaVariable sv;
    private SchemaVariable asSort = null;
    private Sort sort = null;

    public NewVarcond(SchemaVariable sv, SchemaVariable asSort) {
	this.sv=sv;
	this.asSort=asSort;
    }

    public NewVarcond(SchemaVariable sv, Sort sort) {
	this.sv=sv;
	this.sort=sort;
    }

    public boolean isDefinedByType() {
	return asSort==null;
    }

    public SchemaVariable getSchemaVariable() {
	return sv;
    }

    public SchemaVariable getPeerSchemaVariable() {
	return asSort;
    }

    public Sort getSort() {
	return sort;
    }

    public Object getSortDefiningObject() {
	return isDefinedByType() ? (Object) getSort() : (Object)getPeerSchemaVariable();
    }

    public String toString() {
	return (isDefinedByType() ? ""+sort : "typeof("+getPeerSchemaVariable()
		+")")+" "+sv+" new";
    }

}
