// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.rule.metaconstruct;
import de.uka.ilkd.key.java.JavaInfo;
import de.uka.ilkd.key.java.Statement;
import de.uka.ilkd.key.java.ProgramElement;
import de.uka.ilkd.key.util.NotSupported;
import de.uka.ilkd.key.rule.inst.SVInstantiations;

/** This class is used to perform program transformations needed 
 * for the symbolic execution of a switch-case statement.
 */
public class SwitchToIf extends ProgramMetaConstruct {

     /** creates a switch-to-if ProgramMetaConstruct 
     * @param switch the Statement contained by the meta construct 
     */
    public SwitchToIf(Statement _switch) {
	super("switch-to-if", _switch); 
    }

    /** performs the program transformation needed for symbolic
     * program transformation 
     * @return the transformated program
     */
    public ProgramElement symbolicExecution(ProgramElement pe,
					    JavaInfo javaInfo,
					    SVInstantiations insts) {
	throw new NotSupported("Symbolic execution in class SwitchToIf"+
			    " (pckg rule.metaconstruct) is not implemented yet");
    }

    
}
