// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
package de.uka.ilkd.key.util.install;

import java.io.File;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

/** The installer frame consists of a header, the content pane and a
 * button panel. This content pane is an instance of this class.
 */
public class GlobalSettingsPane extends InstallationPane {

    private InstallationPathChooser[] installPath=
	new InstallationPathChooser[3];

    public GlobalSettingsPane() {
	super("Global");
	setup();
    }
    
    private void setup() {
	setLayout(new BorderLayout());
	Box entries=Box.createVerticalBox();
	// "Where do you have unpacked KeY.tgz?"	
	installPath[0]=new InstallationPathChooser
	    ("key.jar:", 
	     System.getProperty("user.dir")+File.separator+"key.jar",
	     JFileChooser.FILES_ONLY);
	// "From where do you want to start KeY?"
	installPath[1]=new InstallationPathChooser
	    ("Installation-Path:",
	     System.getProperty("user.home")+File.separator+
	     "key"+File.separator, JFileChooser.DIRECTORIES_ONLY);
	// "Where do you have installed TogetherCC?"
	installPath[2]=new InstallationPathChooser
	    ("TogetherCC:", System.getProperty("user.home"),
	     JFileChooser.DIRECTORIES_ONLY);
	for (int i=0; i<installPath.length; i++) {
	    entries.add(installPath[i]);	
	}
	add(entries, BorderLayout.NORTH);	
    }

    public String path(int index) {
	return installPath[index].getPath();
    }

}
