#!/bin/sh
#
# This file is part of KeY - Integrated Deductive Software Design 
# Copyright (C) 2001 Universitaet Karlsruhe, Germany
#
# The KeY system is protected by the GNU General 
# Public License. See LICENSE.TXT for details.
#! /bin/sh
useshell='/bin/sh'
if test -e '/bin/bash' ; then
   useshell='/bin/bash'
   read_options='-e'
else
   read_options=''
fi
#!$useshell
#the Makefile passes over the binary path 
binarypath=$1

#set variable togetherhome to the directory containing the 
#Together installation
togetherhome=/usr/local/share/Together6.0/

##start

echo "Welcome."
echo "ABSOLUTE PATHS required."
echo "Please enter directory to place KeY configuration files in:"
read $read_options localtogether

echo "Please enter directory containing library files: "
until false; do
read $read_options librarypath
if test -e $librarypath/antlr.jar 
   test -e $librarypath/recoder.jar &&
   test -e $librarypath/xerces-1_4_4.jar &&
   test -e $librarypath/dresden-ocl-demo.jar &&
   test -e $librarypath/xml.jar &&
   test -e $librarypath/junit.jar &&
   test -e $librarypath/JavaCC.zip &&
   test -e $librarypath/mgtp.jar &&
   test -e $librarypath/cup.jar; then
	break;
    fi
    echo "Libraries not complete in "$librarypath"."   
    echo "Please reenter:"   
done;

antlr=$librarypath/antlr.jar
recoder=$librarypath/recoder.jar
tudresden=$librarypath/dresden-ocl-demo.jar
xerces=$librarypath/xerces-1_4_4.jar:$librarypath/xml.jar
junit=$librarypath/junit.jar
javacc=$librarypath/JavaCC.zip
mgtp=$librarypath/mgtp.jar
cup=$librarypath/cup.jar
gf=$librarypath/gf

echo [Create config files]
classpathdev=$javacc":"$junit":"$togetherhome"/lib/openapi.jar:"$togetherhome"/lib/jgl.zip:"$togetherhome"/lib/together.jar:"$togetherhome"/modules/:"$binarypath
classpathcommon=$antlr":"$recoder":"$tudresden":"$xerces":"$mgtp":"$cup
`dirname $0`/createConfig $classpathcommon \
                $localtogether \
                $togetherhome \
                $binarypath \
                $classpathdev > config.mk

java -cp $binarypath de.uka.ilkd.key.util.make.Config config.mk dev 60 $gf
chmod u+x install_dev.key
echo [Begin installation]
./install_dev.key
rm -f install_dev.key
rm -f miscConfigExtension

